#!/usr/bin/env python3
# -*- encoding: utf-8 -*-

from django.db import models


VALID_LANGUAGES_LST = 'en,es,de,fr,pt'.split(',')
VALID_LANGUAGES = tuple(zip(
    *(VALID_LANGUAGES_LST, 'English,Español,Deutsch,Français,Português'.split(','))
))
VALID_LANGUAGES_DICT = dict(VALID_LANGUAGES)
LANGUAGES_SCOLDING = '''
I guessed you were writing in "{0}" and I have the following suggestions:
Supuse que estabas escribiendo en "{0}" y tengo las siguientes sugerencias:
Ich vermute, Sie haben auf "{0}" geschrieben und ich habe die folgenden Vorschläge:
J'ai deviné que vous écriviez en "{0}" et j'ai les suggestions suivantes:
Imaginei que você estivesse escrevendo em "{0}" e tenho as seguintes sugestões:'''.splitlines()[1:]
LANGUAGES_SCOLDING_DICT = dict(tuple(zip(
    *(VALID_LANGUAGES_LST, LANGUAGES_SCOLDING)
)))


class Group(models.Model):
    chat_id = models.IntegerField(
        default=0,
        blank=False,
        null=False,
        unique=True
    )
    name = models.CharField(
        default="",
        blank=False,
        null=False,
        max_length=255
    )

    def __str__(self):
        return f'{self.pk} - {self.name}'

    class Meta:
        indexes = [
            models.Index(fields=['id']),
            models.Index(fields=['chat_id']),
        ]


class GroupDictionaryEntry(models.Model):
    group = models.ForeignKey(
        Group,
        on_delete=models.CASCADE,
        related_name='words'
    )
    word = models.TextField(
        default="",
        blank=False,
        null=False
    )

    def __str__(self):
        return f'{self.pk} - {self.word}'

    class Meta:
        indexes = [
            models.Index(fields=['id']),
            models.Index(fields=['group_id']),
        ]
